/*
   vda2fbd: convert from VDA/FS to fbd format
   Copyright 1995 Johannes Barner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include	<stdlib.h>
#include	<stdio.h>
#include	"fbd.h"

/*
 *         head->next->next->........->next->tail
 *   out<-   n     n-1   n-2              2     1   <-in
 */

FAM_LINE	init_fam_line_queue()
{
	FAM_LINE	head;

	head = (FAM_LINE)malloc( sizeof( struct fam_line ) );
	strcpy( head->name, "head\0" );
	head->next = NULL;
	return head;
}

FAM_LINE	delete_fam_line_queue(	FAM_LINE	*head )
{
	free( *head );
	return NULL;
}

FAM_LINE	enqueue_fam_line(	FAM_LINE	*tail,
					char		*name )
{
	FAM_LINE	new_tail;

	new_tail = (FAM_LINE)malloc( sizeof( struct fam_line ) );
	strcpy( new_tail->name, name );
	new_tail->next = NULL;
	(*tail)->next = new_tail;
	return new_tail;
}

FAM_LINE	dequeue_fam_line(	FAM_LINE	head )
{
	FAM_LINE	head_line;

	head_line = head->next;
	head->next = head_line->next;
	return head_line;
}
