/*
   vda2fbd: convert from VDA/FS to fbd format
   Copyright 1995 Johannes Barner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include	<stdlib.h>
#include	<stdio.h>
#include	"vda.h"

VDA_SET	enqueue_vdaset(	VDA	model,
			VDA_SET	new	)
{
	VDA_SET	last = model->set;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_HEADER	enqueue_header(	VDA_SET		set,
				VDA_HEADER	new	)
{
	VDA_HEADER	last = set->header;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_POINT	enqueue_point(	VDA_SET		set,
				VDA_POINT	new	)
{
	VDA_POINT	last = set->point;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_PSET	enqueue_pset(	VDA_SET		set,
				VDA_PSET	new	)
{
	VDA_PSET	last = set->pset;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_MDI	enqueue_mdi(	VDA_SET	set,
			VDA_MDI	new	)
{
	VDA_MDI	last = set->mdi;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_CIRCLE	enqueue_circle(	VDA_SET		set,
				VDA_CIRCLE	new	)
{
	VDA_CIRCLE	last = set->circle;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_CURVE	enqueue_curve(	VDA_SET		set,
				VDA_CURVE	new	)
{
	VDA_CURVE	last = set->curve;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

POLY_1	enqueue_poly1(	VDA_CURVE	curve,
			POLY_1		new	)
{
	POLY_1	last;

	while( curve->next != NULL )
		curve = curve->next;
	last = curve->poly;
	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_SURFACE	enqueue_surface(	VDA_SET		set,
					VDA_SURFACE	new	)
{
	VDA_SURFACE	last = set->surface;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

POLY_2	enqueue_poly2(	VDA_SURFACE	surface,
			POLY_2		new	)
{
	POLY_2	last;

	while( surface->next != NULL )
		surface = surface->next;
	last = surface->poly;
	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_CONS	enqueue_cons(	VDA_SET		set,
				VDA_CONS	new	)
{
	VDA_CONS	last = set->cons;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_FACE	enqueue_face(	VDA_SET		set,
				VDA_FACE	new	)
{
	VDA_FACE	last = set->face;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_TOP	enqueue_top(	VDA_SET	set,
			VDA_TOP	new	)
{
	VDA_TOP	last = set->top;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_GROUP	enqueue_group(	VDA_SET		set,
				VDA_GROUP	new	)
{
	VDA_GROUP	last = set->group;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_TMAT	enqueue_tmat(	VDA_SET		set,
				VDA_TMAT	new	)
{
	VDA_TMAT	last = set->tmat;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

VDA_TLIST	enqueue_tlist(	VDA_SET		set,
				VDA_TLIST	new	)
{
	VDA_TLIST	last = set->tlist;

	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

CONS_CURVE	enqueue_cons_curve(	VDA_CONS	cons,
					CONS_CURVE	new	)
{
	CONS_CURVE	last;

	while( cons->next != NULL )
		cons = cons->next;
	last = cons->cons_curve;
	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

FACE_CONS	enqueue_face_cons(	VDA_FACE	face,
					FACE_CONS	new	)
{
	FACE_CONS	last_cons;
	FACE_LOOP	last_loop;

	while( face->next != NULL )
		face = face->next;
	last_loop = face->loop;
	while( last_loop->next != NULL )
		last_loop = last_loop->next;
	last_cons = last_loop->face_cons;
	while( last_cons->next != NULL )
		last_cons = last_cons->next;
	last_cons->next = new;
	return new;
}

FACE_LOOP	enqueue_face_loop(	VDA_FACE	face,
					FACE_LOOP	new	)
{
	FACE_LOOP	last;

	while( face->next != NULL )
		face = face->next;
	last = face->loop;
	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}

TOP_CONS	enqueue_top_cons(	VDA_TOP		top,
					TOP_CONS	new	)
{
	TOP_CONS	last_cons;
	TOP_FACE	last_face;

	while( top->next != NULL )
		top = top->next;
	last_face = top->face;
	while( last_face->next != NULL )
		last_face = last_face->next;
	last_cons = last_face->cons;
	while( last_cons->next != NULL )
		last_cons = last_cons->next;
	last_cons->next = new;
	return new;
}

TOP_FACE	enqueue_top_face(	VDA_TOP		top,
					TOP_FACE	new	)
{
	TOP_FACE	last;

	while( top->next != NULL )
		top = top->next;
	last = top->face;
	while( last->next != NULL )
		last = last->next;
	last->next = new;
	return new;
}
