/*
   vda2fbd: convert from VDA/FS to fbd format
   Copyright 1995 Johannes Barner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	"vda.h"
#include	"vda_util.h"

int	max_u_order = 0, max_v_order = 0;
int	n_points = 0;
int	n_curves = 0;
int	n_surfaces = 0;
int	n_patches = 0;

extern	FILE	*yyin;
VDA	model;

void true_show( VDA_SHOW show )
{
    show->header   = TRUE;
    show->points   = TRUE;
    show->curves   = TRUE;
    show->patches  = FALSE;
    show->surfaces = TRUE;
    show->faces    = TRUE;
    show->layers   = TRUE;
    strcpy( show->symbol, "I000\0" );
}


void false_show( VDA_SHOW show )
{
    show->header   = FALSE;
    show->points   = FALSE;
    show->curves   = FALSE;
    show->patches  = FALSE;
    show->surfaces = FALSE;
    show->faces    = FALSE;
    show->layers   = FALSE;
    strcpy( show->symbol, "I000\0" );
}

int	main( int argc, char **argv )
{
    char *model_name = "VDA_model";
    char key[4] = "\0\0\0\0";
    VDA_SHOW show;
    int i;

    extern void vda2fam();
    extern void yyparse();

    show = (VDA_SHOW)malloc( sizeof( struct vda_show ) );
    show->symbol = (char*)malloc( 5 );
    true_show( show );
    for (i = 1; i < argc-1; i++) {
        strncpy( key, argv[i], 3 );
	if        (strcmp(argv[i], "h") == 0) {
	    false_show( show );
	    show->header = TRUE;
	} else if (strcmp(argv[i], "p") == 0) {
	    false_show( show );
	    show->points = TRUE;
	} else if (strcmp(argv[i], "c") == 0) {
	    false_show( show );
	    show->curves = TRUE;
	} else if (strcmp(argv[i], "patch") == 0) {
	    false_show( show );
	    show->patches = TRUE;
	} else if (strcmp(argv[i], "s") == 0) {
	    false_show( show );
	    show->surfaces = TRUE;
	} else if (strcmp(argv[i], "f") == 0) {
	    false_show( show );
	    show->curves   = TRUE;
	    show->surfaces = TRUE;
	    show->faces    = TRUE;
	} else if (strcmp(argv[i], "l") == 0) {
	    true_show( show );

	} else if (strcmp(argv[i], "-h") == 0) {
	    show->header = FALSE;
	} else if (strcmp(argv[i], "-p") == 0) {
	    show->points = FALSE;
	} else if (strcmp(argv[i], "-c") == 0) {
	    show->curves = FALSE;
	    show->faces = FALSE;
	} else if (strcmp(argv[i], "-patch") == 0) {
	    show->patches = FALSE;
	} else if (strcmp(argv[i], "-s") == 0) {
	    show->surfaces = FALSE;
	    show->faces = FALSE;
	} else if (strcmp(argv[i], "-f") == 0) {
	    show->faces = FALSE;
	} else if (strcmp(argv[i], "-l") == 0) {
	    show->layers = FALSE;

	} else if (strcmp(argv[i], "-symbol") == 0) {
	    show->symbol[0] = argv[i+1][0];
            i++;
	} else {
	    printf("Bad option: %s\n", argv[i]);
	    return 1;
	}
    }

    model = init_vda( model_name );

    yyin = fopen( argv[argc-1], "r" );
    yyparse();

    vda2fam( model, show );

    fclose( yyin );

    return 0;
}
