/*
   vda2fbd: convert from VDA/FS to fbd format
   Copyright 1995 Johannes Barner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include	<stdio.h>
#include	"vda.h"

VDA_SET	push_vdaset(	VDA	model,
			VDA_SET	new	)
{
	VDA_SET	old = model->set->next;

	model->set->next = new;
	new->next = old;
	return new;
}

VDA_POINT	push_point(	VDA_SET		set,
				VDA_POINT	new	)
{
	VDA_POINT	old = set->point->next;

	set->point->next = new;
	new->next = old;
	return new;
}

VDA_PSET	push_pset(	VDA_SET		set,
				VDA_PSET	new	)
{
	VDA_PSET	old = set->pset->next;

	set->pset->next = new;
	new->next = old;
	return new;
}

VDA_MDI	push_mdi(	VDA_SET	set,
			VDA_MDI	new	)
{
	VDA_MDI	old = set->mdi->next;

	set->mdi->next = new;
	new->next = old;
	return new;
}

VDA_CIRCLE	push_circle(	VDA_SET		set,
				VDA_CIRCLE	new	)
{
	VDA_CIRCLE	old = set->circle->next;

	set->circle->next = new;
	new->next = old;
	return new;
}

VDA_CURVE	push_curve(	VDA_SET		set,
				VDA_CURVE	new	)
{
	VDA_CURVE	old = set->curve->next;

	set->curve->next = new;
	new->next = old;
	return new;
}

VDA_SURFACE	push_surface(	VDA_SET		set,
				VDA_SURFACE	new	)
{
	VDA_SURFACE	old = set->surface->next;

	set->surface->next = new;
	new->next = old;
	return new;
}

POLY_1	push_poly1(	VDA_CURVE	curve,
			POLY_1		new	)
{
	POLY_1	old = curve->poly->next;

	curve->poly->next = new;
	new->next = old;
	return new;
}

POLY_2	push_poly2(	VDA_SURFACE	surface,
			POLY_2	new	)
{
	POLY_2	old = surface->poly->next;

	surface->poly->next = new;
	new->next = old;
	return new;
}
