/*
   vda2fbd: convert from VDA/FS to fbd format
   Copyright 1995 Johannes Barner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

%{
#include	<string.h>
#include	"y.tab.h"
%}

SIGN		[+-]
DIGIT		[0-9]
INT		({SIGN})?{DIGIT}+
EXP		[DEde]({SIGN})?{DIGIT}+
REAL		({SIGN})?(({DIGIT}+"."{DIGIT}*)|({DIGIT}*"."{DIGIT}+))({EXP})?
NAME		[A-Z][A-Z0-9]*
ITEM		{NAME}" "*"="" "*
HEAD		"HEADER"" "*"/"" "*{INT}
NUM		{DIGIT}{8}
COMMENT		^\$\$.*

	int	i, j, header_lines, line_number = 0;
	char	item[80], name[80], ident[80];

%s      header

%%
        char    c;
	extern char *index (const char *s, int c);
	
{HEAD}	{	sscanf( (char*)index( yytext, '/' ), "%c%d", &c, &header_lines );
                BEGIN( header );
	        return HEADER;
	}
<header>.*	{
	       	for( j = 0; j < strlen( yytext ) && j < 72; j++ )
	       		item[j] = yytext[j];
       		item[j] = '\0';
		yylval.s = item;
	       	} 
<header>\n      { if( line_number++ == header_lines ) BEGIN( INITIAL ); }

{COMMENT}      	;
{NUM}		;
BEGINSET	return BEGINSET;
POINT		return POINT;
PSET		return PSET;
MDI		return MDI;
CIRCLE		return CIRCLE;
CURVE		return CURVE;
SURF		return SURF;
CONS		return CONS;
FACE		return FACE;
TOP		return TOP;
GROUP		return GROUP;
TMAT		return TMAT;
TLIST		return TLIST;
ENDSET		return ENDSET;
END		return END;
{INT}		{ sscanf( yytext, "%d",  &yylval.i ); return INT;  }
{REAL}		{ sscanf( yytext, "%lf", &yylval.r ); return REAL; }
{ITEM}	{	i = 0;
		while( yytext[i] != '=' && yytext[i] != ' ' && yytext[i] != '\0' ) {
			item[i]  = yytext[i];
			i++;
			}
		item[i]  = '\0';
		yylval.t = item;
		return( ITEM );
	}
{NAME}	{	i = 0;
		while( yytext[i] != ' ' && yytext[i] != ',' && yytext[i] != '\0' ) {
			name[i]  = yytext[i];
			i++;
			}
		name[i]  = '\0';
		yylval.s = name;
		return( NAME );
	}
[ ,/]		;
\n		line_number++;
.               ;
%%
